#include "global.h"


/* Default configuration values */
struct Config cfg = {
    TMPDIR,				/* TmpDir	*/
    WWWDIR,				/* TargetDir	*/
    NULL,				/* Site		*/
    LOGFILE,				/* Log		*/
    ETCDIR"/free-sa.conf",		/* Config	*/
    NULL,				/* utFile	*/
    NULL,				/* dldFile	*/
    NULL,				/* gfFile	*/
    NULL,				/* lfFile	*/
    NULL,				/* Logo		*/
    NULL,				/* Name		*/
    NULL,				/* ER		*/
    "",					/* Locale	*/
    0.0,				/* DLDMin	*/
    5000L,				/* RTRTimeOut	*/
    SAMAXTIMET,				/* Rotate	*/
    { 50, 50, 50, 50, 50, 50, 50, 50 },	/* ttUserLimit	*/
    -1,					/* LogFormat	*/
    50,					/* URLLimit	*/
    0,					/* TSLimit	*/
    5,					/* AutoRecords	*/
    0,					/* Overwrite	*/
    'b',				/* Divisor	*/
    1,					/* INameUser	*/
    0,					/* UserUnescape	*/
    0,					/* ResolveIP	*/
    0,					/* FullTraffic	*/
    1,					/* ShowInfo	*/
    1,					/* Indics	*/
    1,					/* FullURL	*/
    1,					/* UR		*/
    1,					/* TSR		*/
    1,					/* PER		*/
    { 1, 1, 1, 1, 1, 1, 0, 0 },		/* TTR		*/
};

struct owConfig owcfg = {
    NULL,				/* Log		*/
    NULL				/* ER		*/
};

struct iConfig icfg = {
    NULL,				/* locDivisor	*/
    NULL,				/* ReportDir	*/
    NULL,				/* CharSet	*/
    NULL,				/* locFile	*/
    ".total",				/* TTLname	*/
    ".average",				/* AVGname	*/
    "description",			/* DFname	*/
    "index",				/* IRname	*/
    "index",				/* LRname	*/
    "topuser",				/* TURname	*/
    "topsites",				/* TSRname	*/
    "email",				/* ERname	*/
    "proxy_efficiency",			/* PERname	*/
    {    				/* TTRname	*/
	"paf",
	"saf",
	"pdn",
	"sdn",
	"cct",
	"pst",
	"dld",
	"lcf"
    },
    0,					/* SYear	*/
    0,					/* EYear	*/
    0L,					/* SDate	*/
    SAMAXTIMET,				/* EDate	must be high enough */
    0,					/* LocDateLen	*/
    0,					/* dldCount	*/
    0,					/* utCount	*/
    0,					/* ueCount	*/
    1.0,				/* Divisor	*/
    NULL,				/* Downloads	*/
    NULL,				/* Usertab	*/
    "\000",				/* Period	*/
    SAB0,				/* SAB		*/
    0,					/* GF		*/
    0,					/* Mode		*/
    31					/* PScale	*/
};

struct Localisation defloc = {
    "No",				/* No			*/
    "User",				/* User			*/
    "Requests",				/* Connections		*/
    "Seconds",				/* Seconds		*/
    "Bytes",				/* Bytes		*/
    "URL",				/* URL			*/
    "Period",				/* Period		*/
    "Sort field (order)",		/* SortFieldNOrder	*/
    "Users",				/* Users		*/
    "Served",				/* Served		*/
    "Actual",				/* Actual		*/
    "Cashed",				/* Cashed		*/
    "Traffic type",			/* TrafType		*/
    "Other local",			/* OthLocal		*/
    "Top user",				/* TopUser		*/
    "Top sites",			/* TopSites		*/
    "Proxy efficiency",			/* PEfficiency		*/
    " in real time",			/* InRealTime		*/
    "Date and Time",			/* DnT			*/
    "Date\\Time",			/* DsT			*/
    "Day of month",			/* DoM			*/
    "asc.",				/* Asc			*/
    "desc.",				/* Desc			*/
    "TOTAL",				/* TOTAL		*/
    "AVERAGE",				/* AVERAGE		*/
    "MAXIMUM",				/* MAXIMUM		*/
    "Code",				/* Code			*/
    "Generated by",			/* GeneratedBy		*/
    "Configuation",			/* Configuration	*/
    "Generation date",			/* GenerationD		*/
    "Period selection page",		/* PSP			*/
    {					/* TT[TTNUMBER]		*/
	"Proxy auth failures",
	"Site auth failures",
	"Proxy denied (ACL)",
	"Site denied",
	"CONNECT method",
	"PUT/POST method",
	"Downloads",
	"Local filter"
    },
    "P",				/* P			*/
    "T",				/* T			*/
    "G",				/* G			*/
    "M",				/* M			*/
    "k",				/* k			*/
    "Sender",				/* Sender		*/
    "Messages",				/* Messages		*/
    "Recipient",			/* Recipient		*/
    "Senders",				/* Senders		*/
    "Recipients",			/* Recipients		*/
    "Receiving rejected",		/* RecRejected		*/
    "Delivery rejected"			/* DelRejected		*/
};

struct Localisation *loc = &defloc;

struct FConfig gfcfg = {
    0,					/* inameCount		*/
    0,					/* urlCount		*/
    0,					/* codeCount		*/
    NULL,				/* inames		*/
    NULL,				/* urls			*/
    NULL,				/* codes		*/
    NULL,				/* methods		*/
    '\0',				/* stats		*/
    0.0,				/* bytes		*/
    0,					/* inameMode		*/
    0,					/* urlMode		*/
    0,					/* codeMode		*/
    0,					/* methodMode		*/
    0,					/* statMode		*/
    0					/* bytesMode		*/
};

struct FConfig lfcfg = {
    0,					/* inameCount		*/
    0,					/* urlCount		*/
    0,					/* codeCount		*/
    NULL,				/* inames		*/
    NULL,				/* urls			*/
    NULL,				/* codes		*/
    NULL,				/* methods		*/
    '\0',				/* stats		*/
    0.0,				/* bytes		*/
    0,					/* inameMode		*/
    0,					/* urlMode		*/
    0,					/* codeMode		*/
    0,					/* methodMode		*/
    0,					/* statMode		*/
    0					/* bytesMode		*/
};


short int CS2SI(char *ivalue);
short int CS2SI(char *ivalue) {
    short int retval;
    
    if (sscanf(ivalue, "%hd", &retval) != 1) SAexit("Error converting \"%s\" to short int", ivalue);
    
    return retval;
}


double CS2D(char *ivalue);
double CS2D(char *ivalue) {
    double retval;
    
    if (sscanf(ivalue, "%lf", &retval) != 1) SAexit("Error converting \"%s\" to double", ivalue);
    
    return retval;
}


time_t CS2TT(char *ivalue);
time_t CS2TT(char *ivalue) {
    time_t retval;

    if (sscanf(ivalue, "%10ld", &retval) != 1)
	if (!(retval = GetDW(ivalue))) SAexit("Error converting \"%s\" to time_t", ivalue);
	
    return retval;
}


char CS2B(char *ivalue);
char CS2B(char *ivalue) {
    if (ivalue[0] != 't' && ivalue[0] != 'f') SAexit("Error converting \"%s\" to bool", ivalue);
    
    return (ivalue[0] == 't') ? 1 : 0;
}


char CS2C(char *ivalue);
char CS2C(char *ivalue) {
    if (ivalue[1] != '\0') SAexit("Error converting \"%s\" to char", ivalue);

    return ivalue[0];
}


void LoadDownloads(void);
void LoadDownloads(void) {
    char *tBuf, *t;

    if (cfg.dldFile == NULL) SAexit("Downloads report enabled, but no downloads file specified");
    if ((tBuf = (char *)SAfreadMC(NULL, cfg.dldFile)) == NULL) SAexit("Can't stat file");
    
    while((t = strchr(tBuf, '\n')) != NULL) {
	icfg.Downloads = (char **)SArealloc(icfg.Downloads, sizeof(char *) * ((size_t)icfg.dldCount + 1L));
	icfg.Downloads[icfg.dldCount] = tBuf;
	t[0] = '\0';
	tBuf = t + 1L;

#if DEBUG > 0
	SAdebug("%hd\t%s", icfg.dldCount + 1, icfg.Downloads[icfg.dldCount]);
#endif

	icfg.dldCount++;
    }

    /* TTR_DLD: disable if no extensions found */
    if (!icfg.dldCount) {
	SAwarning("Empty file");
	cfg.TTR[DLD] = 0;
    }
}


void LoadUsertab(void);
void LoadUsertab(void) {
    char *tBuf, *t;

    if ((tBuf = (char *)SAfreadMC(NULL, cfg.utFile)) == NULL) SAexit("Can't stat file");
    
    while((t = strchr(tBuf, ' ')) != NULL) {
	icfg.Usertab = (struct SAuconv *)SArealloc(icfg.Usertab, sizeof(struct SAuconv) * ((size_t)icfg.utCount + 1L));
	icfg.Usertab[icfg.utCount].iname = tBuf;
	t[0] = '\0';
	tBuf = t + 1L;
	
	if ((t = strchr(tBuf, '\n')) == NULL) SAexit("Incorrect file format");
	t[0] = '\0';
	icfg.Usertab[icfg.utCount].ename = tBuf;
	tBuf = t + 1L;
	
#if DEBUG > 0
	SAdebug("%hd\t%s->%s", icfg.utCount + 1, icfg.Usertab[icfg.utCount].iname, icfg.Usertab[icfg.utCount].ename);
#endif

	icfg.utCount++;
    }

    if (icfg.utCount) qsort(icfg.Usertab, (size_t)icfg.utCount, sizeof(struct SAuconv), (int (*)(const void *, const void *))compSAuconv);
    else SAwarning("Empty file");
}


void LoadLocalisation(void);
void LoadLocalisation(void) {
    char *tBuf, *t;
    static char *newloc[LOCSIZE];
    short int locCount = 0;

    if ((tBuf = (char *)SAfreadMC(NULL, icfg.locFile)) == NULL) SAexit("Can't stat file");
    
    while((t = strchr(tBuf, '\n')) != NULL) {
	newloc[locCount] = tBuf;
	t[0] = '\0';
	tBuf = t + 1L;

#if DEBUG > 0
	SAdebug("%hd\t%s", locCount + 1, newloc[locCount]);
#endif

	locCount++;
    }

    if (locCount != LOCSIZE) SAexit("Incorrect file format");
    
    loc = (struct Localisation *)((char **)(&newloc));
}


void SAfilterrxcomp(void ***rxchar, short int iCount);
void SAfilterrxcomp(void ***rxchar, short int iCount) {
    short int i;
    regex_t *nrxchar = (regex_t *)SAmalloc(sizeof(regex_t) * (size_t)iCount);

    /* compile regexps */
    for (i = 0; i < iCount; i++) if (regcomp(&nrxchar[i], rxchar[0][i], REG_EXTENDED)) SAexit("Incorrect regular expression '%s'", rxchar[0][i]);
    
    /* reassign pointer to compiled regexps */
    free(*rxchar);
    *rxchar = (void **)nrxchar;
}


char LoadFilter(const char *fFile, struct FConfig *fcfg);
char LoadFilter(const char *fFile, struct FConfig *fcfg) {
    char *tBuf, *t;


    if ((tBuf = (char *)SAfreadMC(NULL, fFile)) == NULL) SAexit("Can't stat file '%s'", fFile);
    
    while((t = strchr(tBuf, '\n')) != NULL) {
	t[0] = '\0';
	switch(tBuf[0]) {
	    case 'b':
		    if (sscanf(&tBuf[2], "%lf", &fcfg->bytes) != 1) goto fferror;
		    break;
	    case 'B':
		    if (tBuf[2] >= '0' && tBuf[2] <= '1') fcfg->bytesMode = tBuf[2] - '0';
		    else goto fferror;
		    break;
	    case 'c':
		    fcfg->codes = (short int *)SArealloc(fcfg->codes, sizeof(short int) * (fcfg->codeCount + 1L));
		    if (sscanf(&tBuf[2], "%hd", &fcfg->codes[fcfg->codeCount]) != 1) goto fferror;
		    fcfg->codeCount++;
		    break;
	    case 'C':
		    if (tBuf[2] >= '0' && tBuf[2] <= '1') fcfg->codeMode = tBuf[2] - '0';
		    else goto fferror;
		    break;
	    case 'i':
		    fcfg->inames = (void **)SArealloc(fcfg->inames, sizeof(char *) * (fcfg->inameCount + 1L));
		    fcfg->inames[fcfg->inameCount] = &tBuf[2];
		    fcfg->inameCount++;
		    break;
	    case 'I':
		    if (tBuf[2] >= '0' && tBuf[2] <= '5') fcfg->inameMode = tBuf[2] - '0';
		    else goto fferror;
		    break;
	    case 'm':
		    if ((!isupper(tBuf[2])) || tBuf[3] != '\0') goto fferror;
		    if (fcfg->methods == NULL) fcfg->methods = SAstrdup(&tBuf[2]);
		    else {
			fcfg->methods = (char *)SArealloc(fcfg->methods, sizeof(char) * (strlen(fcfg->methods) + 2L));
			strncat(fcfg->methods, &tBuf[2], 1L);
		    }
		    break;
	    case 'M':
		    if (tBuf[2] >= '0' && tBuf[2] <= '1') fcfg->methodMode = tBuf[2] - '0';
		    else goto fferror;
		    break;
	    case 's':
		    if (tBuf[2] >= '0' && tBuf[2] <= '3') SAsetbit(fcfg->stats, (tBuf[2] - '0'));
		    else goto fferror;
		    break;
	    case 'S':
		    if (tBuf[2] >= '0' && tBuf[2] <= '1') fcfg->statMode = tBuf[2] - '0';
		    else goto fferror;
		    break;
	    case 'u':
		    fcfg->urls = (void **)SArealloc(fcfg->urls, sizeof(char *) * (fcfg->urlCount + 1L));
		    fcfg->urls[fcfg->urlCount] = &tBuf[2];
		    fcfg->urlCount++;
		    break;
	    case 'U':
		    if (tBuf[2] >= '0' && tBuf[2] <= '5') fcfg->urlMode = tBuf[2] - '0';
		    else goto fferror;
		    break;
	    case '#':
	    case '\n':
		    break;
	    default:
fferror:
		    SAexit("Incorrect file format '%s'", fFile);
		    break;
	}
#if DEBUG > 0
	SAdebug("%c\t%s", tBuf[0], &tBuf[2]);
#endif
	tBuf = t + 1L;
    }

    if (fcfg->inameCount || fcfg->urlCount || fcfg->codeCount || fcfg->methods != NULL || fcfg->stats != '\0' || fcfg->bytes != 0.0) {
	if (fcfg->codeCount) qsort(fcfg->codes, (size_t)fcfg->codeCount, sizeof(short int), (int (*)(const void *, const void *))compSI);
	if (fcfg->inameMode == 2 || fcfg->inameMode == 3) qsort(fcfg->inames, (size_t)fcfg->inameCount, sizeof(char *), (int (*)(const void *, const void *))SApstrcmp);
	else if (fcfg->inameMode == 4 || fcfg->inameMode == 5) SAfilterrxcomp(&fcfg->inames, fcfg->inameCount);
	if (fcfg->urlMode == 2 || fcfg->urlMode == 3) qsort(fcfg->urls, (size_t)fcfg->urlCount, sizeof(char *), (int (*)(const void *, const void *))SApstrcmp);
	else if (fcfg->urlMode == 4 || fcfg->urlMode == 5) SAfilterrxcomp(&fcfg->urls, fcfg->urlCount);
	
	return 1;
    }
    
    SAwarning("Empty file '%s'", fFile);
    return 0;
}


void SAusage(char *iName, char mode, char *itext);
void SAusage(char *iName, char mode, char *itext) {
    const char *const utext = "\
Usage: %s [-s|-r|-F] [-d STARTDATE-ENDDATE] [-f FILE] [-h] [-l FILE] [-v]\n\
  -d STARTDATE-ENDDATE	Dates range for report generation in current locale,\n\
			you may specify only STARTDATE followed by '-' sign,\n\
			or only ENDDATE preceded by '-' sign.\n\
  -e ADDRESS		Send topuser report in text format to e-mail ADDRESS,\n\
			if ADDRESS is '-' then report is writed to stdout.\n\
  -f FILE		Read configuration from FILE.\n\
  -h			Show help message\n\
  -l FILE		Use FILE as log file.\n\
  -s			Show log file information:\n\
			name, size, start and end dates.\n\
  -r			Remove records from log file.\n\
			You must also specify date(s) at '-d' option.\n\
  -v			Show version\n\
  -F			Fix root index.html file according to\n\
			reports directories presense.\n";
    char etext[URLSIZE];
    int elen = 0;


    if (mode == 0) {
	SAshow(utext, iName);
	exit(EXIT_SUCCESS);
    } else {
	switch(mode) {
	    case 1:
		    elen = SAsnprintf(etext, sizeof(etext), "Incorrect option '%s'\n", itext);
		    break;
	    case 2:
		    elen = SAsnprintf(etext, sizeof(etext), "Incorrect dates range specified '%s'\n", itext);
		    break;
	    case 3:
		    elen = SAsnprintf(etext, sizeof(etext), "Option '%s' requires argument\n", itext);
		    break;
	    case 4:
		    elen = SAsnprintf(etext, sizeof(etext), "Too much action options specified\n");
		    break;
	}
	
	SAsnprintf(&etext[elen], URLSIZE - (long)elen, utext, iName);
	SAexit(etext);
    }
}


void InitConfigWithCL(int argc, char **argv) {
    short int i = 1;
    time_t ttime;

    
    /* Parse command line options */
    if (argc > 1)
	for (; i < argc; i++) {
	    if (argv[i][0] != '-' || argv[i][2] != '\0') SAusage(argv[0], 1, argv[i]);
	    switch(argv[i][1]) {
		case 'd':
			if (i == argc - 1) SAusage(argv[0], 3, argv[i]);
			if (islower(argv[i + 1][0])) {	/* assume date as one of predefined words */
			    if (time(&icfg.EDate) == -1L) SAexit("Can't get current date. %s", strerror(errno));
			    if (!(ttime = GetDW(argv[i + 1]))) SAusage(argv[0], 2, argv[i + 1]);
			    icfg.SDate = icfg.EDate - ttime;
			} else {			/* assume date in locale format */
			    if (argv[i + 1][0] == '-') icfg.EDate = GetDZT(&argv[i + 1][1]) + SADAY - 1L;
			    else {
			        if (argv[i + 1][icfg.LocDateLen] != '-') SAusage(argv[0], 2, argv[i + 1]);
			        argv[i + 1][icfg.LocDateLen] = '\0';
			        icfg.SDate = GetDZT(&argv[i + 1][0]);
			        if (argv[i + 1][icfg.LocDateLen + 1] != '\0') icfg.EDate = GetDZT(&argv[i + 1][icfg.LocDateLen + 1]) + SADAY - 1L;
			    }
			}
			i++; /* 2 args readed for this option */
			break;
		case 'e':
			if (i == argc - 1) SAusage(argv[0], 3, argv[i]);
			owcfg.ER = argv[i + 1];
			i++; /* 2 args readed for this option */
			break;
		case 'f':
			if (i == argc - 1) SAusage(argv[0], 3, argv[i]);
			cfg.Config = argv[i + 1];
			i++; /* 2 args readed for this option */
			break;
		case 'h':
			SAusage(argv[0], 0, NULL);
			break;
		case 'l':
			if (i == argc - 1) SAusage(argv[0], 3, argv[i]);
			owcfg.Log = argv[i + 1];
			i++; /* 2 args readed for this option */
			break;
		case 'r':
			if (icfg.Mode != 0) SAusage(argv[0], 4, NULL);
			else icfg.Mode = 3;
			break;
		case 's':
			if (icfg.Mode != 0) SAusage(argv[0], 4, NULL);
			else icfg.Mode = 2;
			break;
		case 'v':
			SAshow(PROGNAME" "PROGVERSION" ("PROGURL")\n");
			exit(0);
			break;
		case 'F':
			if (icfg.Mode != 0) SAusage(argv[0], 4, NULL);
			else icfg.Mode = 4;
			break;
		default:
			SAusage(argv[0], 1, argv[i]);
			break;
	    }
	}

    InitConfig();
}


void InitConfig(void) {
    FILE *CONF;
    char tBuf[128];
    char *value;
    double dpow = 0.0;
    
    
    /* Open configuration file */
    CONF = SAfopenI("r", cfg.Config);
    
    /* Read and parse configuration file */
    while (fgets(tBuf, 128, CONF) != NULL) {
	/* Skip comments and empty lines */
	if (tBuf[0] == '\n' || tBuf[0] == '#') continue;
	
	/* Split for parameter and value at =, remove " from value */
	if ((value = strchr(tBuf, '=')) == NULL) SAexit("Error parsing confuguration file, line was: %s", tBuf);
	value[0] = '\0';
	value += 2L;
	value[strlen(value) - 2L] = '\0';
#if DEBUG>0	
	SAdebug("%s=\"%s\"", tBuf, value);
#endif
	/* Empty value */
	if (value[0] == '\0') continue;
	
	switch(tBuf[0]) {
	    case 'a':
		    if (!strcmp(tBuf, "autorecords")) cfg.AutoRecords = CS2SI(value);
		    else goto opterror;
		    break;
	    case 'c':
		    if (!strcmp(tBuf, "cct_limit")) cfg.ttUserLimit[CCT] = CS2SI(value);
		    else if (!strcmp(tBuf, "cct")) cfg.TTR[CCT] = CS2B(value);
		    else goto opterror;
		    break;
	    case 'd':
		    if (!strcmp(tBuf, "divisor")) cfg.Divisor = CS2C(value);
		    else if (!strcmp(tBuf, "dld_limit")) cfg.ttUserLimit[DLD] = CS2SI(value);
		    else if (!strcmp(tBuf, "dld_min")) cfg.DLDMin = CS2D(value);
		    else if (!strcmp(tBuf, "dld")) cfg.TTR[DLD] = CS2B(value);
		    else if (!strcmp(tBuf, "downloads")) cfg.dldFile = SAstrdup(value);
		    else goto opterror;
		    break;
	    case 'e':
		    if (!strcmp(tBuf, "email")) cfg.ER = SAstrdup(value);
		    else goto opterror;
		    break;
	    case 'f':
		    if (!strcmp(tBuf, "fulltraffic")) cfg.FullTraffic = CS2B(value);
		    else if (!strcmp(tBuf, "fullurl")) cfg.FullURL = CS2B(value);
		    else goto opterror;
		    break;
	    case 'g':
		    if (!strcmp(tBuf, "global_filter")) cfg.gfFile = SAstrdup(value);
		    else goto opterror;
		    break;
	    case 'i':
		    if (!strcmp(tBuf, "inameuser")) cfg.INameUser = CS2B(value);
		    else if (!strcmp(tBuf, "indicators")) cfg.Indics = CS2B(value);
		    else goto opterror;
		    break;
	    case 'l':
		    if (!strcmp(tBuf, "lcf_limit")) cfg.ttUserLimit[LCF] = CS2SI(value);
		    else if (!strcmp(tBuf, "locale")) cfg.Locale = SAstrdup(value);
		    else if (!strcmp(tBuf, "local_filter")) cfg.lfFile = SAstrdup(value);
		    else if (!strcmp(tBuf, "logformat")) cfg.LogFormat = CS2SI(value);
		    else if (!strcmp(tBuf, "logo")) cfg.Logo = SAstrdup(value);
		    else if (!strcmp(tBuf, "log")) cfg.Log = SAstrdup(value);
		    else goto opterror;
		    break;
	    case 'n':
		    if (!strcmp(tBuf, "name")) cfg.Name = SAstrdup(value);
		    else goto opterror;
		    break;
	    case 'o':
		    if (!strcmp(tBuf, "overwrite")) cfg.Overwrite = CS2SI(value);
		    else goto opterror;
		    break;
	    case 'p':
		    if (!strcmp(tBuf, "paf_limit")) cfg.ttUserLimit[PAF] = CS2SI(value);
		    else if (!strcmp(tBuf, "paf")) cfg.TTR[PAF] = CS2B(value);
		    else if (!strcmp(tBuf, "pdn_limit")) cfg.ttUserLimit[PDN] = CS2SI(value);
		    else if (!strcmp(tBuf, "pdn")) cfg.TTR[PDN] = CS2B(value);
		    else if (!strcmp(tBuf, "pst_limit")) cfg.ttUserLimit[PST] = CS2SI(value);
		    else if (!strcmp(tBuf, "pst")) cfg.TTR[PST] = CS2B(value);
		    else goto opterror;
		    break;
	    case 'r':
		    if (!strcmp(tBuf, "resolveip")) cfg.ResolveIP = CS2B(value);
		    else if (!strcmp(tBuf, "rotate")) cfg.Rotate = CS2TT(value);
		    else if (!strcmp(tBuf, "rtr_timeout")) cfg.RTRTimeOut = CS2TT(value);
		    else goto opterror;
		    break;
	    case 's':
		    if (!strcmp(tBuf, "saf_limit")) cfg.ttUserLimit[SAF] = CS2SI(value);
		    else if (!strcmp(tBuf, "saf")) cfg.TTR[SAF] = CS2B(value);
		    else if (!strcmp(tBuf, "sdn_limit")) cfg.ttUserLimit[SDN] = CS2SI(value);
		    else if (!strcmp(tBuf, "sdn")) cfg.TTR[SDN] = CS2B(value);
		    else if (!strcmp(tBuf, "showinfo")) cfg.ShowInfo = CS2B(value);
		    else if (!strcmp(tBuf, "site")) cfg.Site = SAstrdup(value);
		    else goto opterror;
		    break;
	    case 't':
		    if (!strcmp(tBuf, "targetdir")) cfg.TargetDir = SAstrdup(value);
		    else if (!strcmp(tBuf, "tmpdir")) cfg.TmpDir = SAstrdup(value);
		    else if (!strcmp(tBuf, "ts")) cfg.TSR = CS2B(value);
		    else if (!strcmp(tBuf, "ts_limit")) cfg.TSLimit = CS2SI(value);
		    else goto opterror;
		    break;
	    case 'u':
		    if (!strcmp(tBuf, "user_unescape")) cfg.UserUnescape = CS2B(value);
		    else if (!strcmp(tBuf, "url_limit")) cfg.URLLimit = CS2SI(value);
		    else if (!strcmp(tBuf, "users")) cfg.UR = CS2B(value);
		    else if (!strcmp(tBuf, "usertab")) cfg.utFile = SAstrdup(value);
		    else goto opterror;
		    break;
	    default:
opterror:
		    SAexit("Unknown parameter '%s' with value '%s'", tBuf, value);
		    break;
	}
    }

    /* Close configuration file */
    SAfclose(CONF, cfg.Config);

    /* Command line options arguments is preferred over config file */
    if (owcfg.Log != NULL) cfg.Log = owcfg.Log;
    if (owcfg.ER  != NULL) cfg.ER  = owcfg.ER;

    /* If alternative mode not selected at CL, then choose log processing */
    if (icfg.Mode == 0)	icfg.Mode = 1;
    /* Disable overwrite mode, because we will not generate reports */
    else cfg.Overwrite = 0;

    /* If alternative locale specified, reinitialise it */
    if (cfg.Locale[0] != '\0') InitLocale();

    /* If no configuration name specified, then use config file name */
    if (cfg.Name == NULL) cfg.Name = cfg.Config;

    /* Load files, which configuration depend */
    if (cfg.TTR[DLD]) LoadDownloads();
    if (cfg.utFile != NULL) LoadUsertab();
    if (icfg.locFile != NULL) LoadLocalisation();
    if (cfg.gfFile != NULL) icfg.GF = LoadFilter(cfg.gfFile, &gfcfg);
    if (cfg.lfFile != NULL) cfg.TTR[LCF] = LoadFilter(cfg.lfFile, &lfcfg);
    
    if (cfg.FullURL && !cfg.UR) SAexit("User report with full URLs enabled, but user report (UR) is diabled");
    
    /* Compute result of bytes division name AFTER InitLocale */
    switch (cfg.Divisor) {
        case 'b':
        case 'B': icfg.SAB = SAB0; dpow =  0.0; break;
        case 'k': icfg.SAB = SAB1; dpow = 10.0; icfg.locDivisor = loc->k; break;
        case 'K': icfg.SAB = SAB2; dpow = 10.0; icfg.locDivisor = loc->k; break;
        case 'm': icfg.SAB = SAB1; dpow = 20.0; icfg.locDivisor = loc->M; break;
        case 'M': icfg.SAB = SAB2; dpow = 20.0; icfg.locDivisor = loc->M; break;
        case 'g': icfg.SAB = SAB1; dpow = 30.0; icfg.locDivisor = loc->G; break;
        case 'G': icfg.SAB = SAB2; dpow = 30.0; icfg.locDivisor = loc->G; break;
        case 't': icfg.SAB = SAB1; dpow = 40.0; icfg.locDivisor = loc->T; break;
        case 'T': icfg.SAB = SAB2; dpow = 40.0; icfg.locDivisor = loc->T; break;
        case 'p': icfg.SAB = SAB1; dpow = 50.0; icfg.locDivisor = loc->P; break;
        case 'P': icfg.SAB = SAB2; dpow = 50.0; icfg.locDivisor = loc->P; break;
        case 'v':
        case 'V': icfg.SAB = SAB3; dpow =  0.0; break;
        default: SAexit("Incorrect divisor specified: '%c'", cfg.Divisor); break;
    }
    icfg.Divisor = pow(2.0,  dpow);
    
    SAB3variants[0].munit = loc->P;
    SAB3variants[1].munit = loc->T;
    SAB3variants[2].munit = loc->G;
    SAB3variants[3].munit = loc->M;
    SAB3variants[4].munit = loc->k;
}


void InitLocale(void) {
    char locstring[FILENAMESIZE];
    const char *t = NULL;
    char *curlocale;
    short int i;

    
    /* Init locale */
    if ((curlocale = setlocale(LC_ALL, cfg.Locale)) == NULL) SAexit("Can't initialize locale");
    icfg.CharSet = nl_langinfo(CODESET);
    
    /* Compute crossplatform charset and fill with it localisation file name only if we not in C locale */
    if ((curlocale[0] != 'C' && curlocale[1] != '\0') && (curlocale[0] != 'L' && curlocale[1] != 'C')) {
	i = SAsnprintf(locstring, sizeof(locstring), LOCDIR"/%c%c.", curlocale[0], curlocale[1]);
	for (t = icfg.CharSet; t[0] != '\0'; t++) {
	    if (t[0] == '-') continue;
	    locstring[i++] = (char)tolower((int)t[0]);
	}
	locstring[i] = '\0';
	icfg.locFile = SAstrdup(locstring);
#if DEBUG >= 1
	SAdebug("Selected localisation file: %s", icfg.locFile);
#endif
    }
#if DEBUG >= 1
    else SAdebug("Selected localisation file: internal English");
#endif
    
    /* Export variables for spawned programs */
    SAsnprintf(locstring, sizeof(locstring), "LC_ALL=%s", cfg.Locale);
    if (putenv(locstring)) SAexit("Can't set LC_ALL to %s", locstring);
    if (putenv("LC_COLLATE=POSIX")) SAexit("Can't set LC_COLLATE to POSIX");

    /* Compute max date length */    
    icfg.LocDateLen = strlen(GetDT(SALONGDATE, "%x"));
}
