typedef struct Config {
    const char	*TmpDir;
    const char	*TargetDir;
    const char	*Site;
    const char	*Log;
    const char	*Config;
    const char	*utFile;
    const char	*dldFile;
    const char	*gfFile;
    const char  *lfFile;
    const char	*Logo;
    const char	*Name;
    const char  *ER;
    const char  *Locale;
    double	DLDMin;
    time_t	RTRTimeOut;
    time_t	Rotate;
    short int	ttUserLimit[TTNUMBER];
    short int	LogFormat;
    short int	URLLimit;
    short int	TSLimit;
    short int	AutoRecords;
    short int	Overwrite;
    char	Divisor;
    char	INameUser;
    char	UserUnescape;
    char	ResolveIP;
    char	FullTraffic;
    char	ShowInfo;
    char	Indics;
    char	FullURL;
    char	UR;
    char	TSR;
    char	PER;
    char	TTR[TTNUMBER];
} Config;

typedef struct owConfig {
    const char	*Log;
    const char	*ER;
} owConfig;

typedef struct iConfig {
    const char	*locDivisor;
    const char	*ReportDir;
    const char	*CharSet;
    const char	*locFile;
    const char	*TTLname;
    const char	*AVGname;
    const char	*DFname;
    const char	*IRname;
    const char	*LRname;
    const char	*TURname;
    const char	*TSRname;
    const char  *ERname;
    const char	*PERname;
    const char	*TTRname[TTNUMBER];
    short int	SYear;
    short int	EYear;
    time_t	SDate;
    time_t	EDate;
    short int	LocDateLen;
    short int	dldCount;
    short int	utCount;
    short int	ueCount;
    double	Divisor;
    char	**Downloads;
    struct SAuconv *Usertab;
    char	Period[DATETIMESIZE * 2L];
    char	*(*SAB)(double);
    char	GF;
    char	Mode;
    char	PScale;
} iConfig;

typedef struct Localisation {
    const char	*No;
    const char	*User;
    const char	*Connections;
    const char	*Seconds;
    const char	*Bytes;
    const char	*URL;
    const char	*Period;
    const char	*SortFieldNOrder;
    const char	*Users;
    const char	*Served;
    const char	*Actual;
    const char	*Cashed;
    const char	*TrafType;
    const char	*OthLocal;
    const char	*TopUser;
    const char	*TopSites;
    const char	*PEfficiency;
    const char	*InRealTime;
    const char	*DnT;
    const char	*DsT;
    const char	*DoM;
    const char	*Asc;
    const char	*Desc;
    const char	*TOTAL;
    const char	*AVERAGE;
    const char	*MAXIMUM;
    const char	*Code;
    const char	*GeneratedBy;
    const char	*Configuration;
    const char	*GenerationD;
    const char	*PSP;
    const char	*TT[TTNUMBER];
    const char	*P;
    const char	*T;
    const char	*G;
    const char	*M;
    const char	*k;
    const char	*Sender;
    const char	*Messages;
    const char	*Recipient;
    const char	*Senders;
    const char	*Recipients;
    const char	*RecRejected;
    const char	*DelRejected;
} Localisation;

typedef struct FConfig {
    short int	inameCount;
    short int	urlCount;
    short int	codeCount;
    void	**inames;
    void	**urls;
    short int	*codes;
    char	*methods;
    char	stats;
    double	bytes;
    char	inameMode;
    char	urlMode;
    char	codeMode;
    char	methodMode;
    char	statMode;
    char	bytesMode;
} FConfig;


extern struct Config cfg;
extern struct owConfig owcfg;
extern struct iConfig icfg;
extern struct Localisation defloc;
extern struct Localisation *loc;
extern struct FConfig gfcfg;
extern struct FConfig lfcfg;


extern void InitConfigWithCL(int argc, char **argv);
extern void InitConfig(void);
extern void InitLocale(void);


#define	LOCSIZE	sizeof(Localisation)/sizeof(char *)
