typedef struct SAentry {
    FILE	*file;
    char	fname[FILENAMESIZE];
    const char	*ip;
    const char	*name;
    const char	*vname;
    double	Bytes;
    int		count;
    int		TTcount[TTNUMBER];
} SAentry;

typedef struct SAuconv {
    char	*iname;
    char	*ename;
} SAuconv;

typedef struct SAB3v {
    const double        vlimit;
    const char          *munit;
    const double        divisor;
} SAB3v;


extern struct SAentry *Users;
extern char rurl[URLSIZE];
extern struct SAB3v SAB3variants[6];


extern int compSAentry(const struct SAentry *el1, const struct SAentry *el2);
extern int compSAuconv(const struct SAuconv *el1, const struct SAuconv *el2);
extern int rcompSAentryB(const struct SAentry *el1, const struct SAentry *el2);
extern int compSI(const short int *el1, const short int *el2);
extern struct SAentry *SAentryByName(const char *sname);
extern const char *LimitedURL(const char *lurl);
extern char *FixFileName(char *tfname);
extern char *SAB0(double ibytes);
extern char *SAB1(double ibytes);
extern char *SAB2(double ibytes);
extern char *SAB3(double ibytes);
extern char *GetDT(time_t idt, const char *fmt);
extern char *GetD(struct tm *itm, const char *fmt);
extern time_t GetDZT(const char *idate);
extern time_t GetDW(const char *iperiod);
extern void ComputePeriod(time_t rsdate, time_t redate);
extern void Indics(FILE *iFile, short int iIndic);
extern void IndicsByIndex(FILE *iFile, int i);
extern void SAunescape(char *istring);
